﻿CLASS dbStandard INHERIT dbServer
	// Vorlage für alle DBServer
	PROTECT aDbf AS ARRAY


METHOD AppendRecycle(lReleaseLocks) 
	// Gelöschte Datensätze recyclen oder neuen Datensatz anlegen
	LOCAL lDeleted := SetDeleted() AS LOGIC
	LOCAL lReturn AS LOGIC
	LOCAL odb AS dbServer
	LOCAL nRecno AS DWORD

	SetDeleted(FALSE)
	odb := dbServer{SELF:FileSpec:FileName, DBSHARED, DBREADONLY}
	odb:SetFilter({|| DELETED()}, "Deleted()")
	odb:GoTop()
	nRecno := IIF(odb:Deleted, odb:Recno, 0)
	odb:Close()

	SELF:SuspendNotification()
	lReturn := FALSE
	IF nRecno > 0
		SELF:GoTo(nRecno)
		IF SELF:Deleted  .AND. SELF:RLOCK()
			lReturn := SELF:Recall()
		ENDIF
	ENDIF

	IF !lReturn
		lReturn := SELF:Append(lReleaseLocks)
	ENDIF
	SetDeleted(lDeleted)
	SELF:ResetNotification()

	RETURN lReturn


METHOD DeleteRecycle(cbForBlock, cbWhileBlock, uScope) 
	// Aktuellen Datensatz löschen und Felder leeren
	LOCAL x AS DWORD

	IF Empty(cbForblock)  .AND. Empty(cbWhileBlock)  .AND. Empty(uScope)
		FOR x := 1 TO SELF:FCount
			DO CASE
			CASE SELF:FieldInfo(DBS_TYPE, x) = "C"
 				SELF:FIELDPUT(x, NULL_STRING)
			CASE SELF:FieldInfo(DBS_TYPE, x) = "D"
 				SELF:FIELDPUT(x, NULL_DATE)
			CASE SELF:FieldInfo(DBS_TYPE, x) = "N"
 				SELF:FIELDPUT(x, 0)
	 		ENDCASE
 		NEXT
	ENDIF

	RETURN  SELF:Delete(cbForBlock, cbWhileBlock, uScope)


CONSTRUCTOR (cFileName, lDbShared, lReadOnly) 
	// Init mit ev. Anlage DBF + CDX, Open DBF + CDX
	LOCAL cFile, cDbf AS STRING

	Default (@lReadOnly, FALSE)
	Default (@lDbShared, TRUE)

//	cFile := GetDefault() + cFileName
	cFile := cFileName

	cDbf := dbFileSpec{cFile + ".DBF"}:FullPath
	SUPER:init (cDbf, lDbShared, lReadOnly)
	SELF:concurrencyControl := CCNONE
	IF File(StrTran(cDbf, ".DBF", ".CDX"))
		SELF:setIndex (StrTran(cDbf, ".DBF", ".CDX"))
	ENDIF

	RETURN SELF

METHOD OrderInfo (kType, uFileSpec, uOrder, uVal) 

   IF kType == DBOI_ISDESC
      RETURN SELF:orderDescend (uFileSpec, uOrder, uVal)
   ELSE
      RETURN SUPER:orderInfo (kType, uFileSpec, uOrder, uVal)
   ENDIF



END CLASS
