﻿CLASS dtaKgr INHERIT dtaKgr_vo


METHOD ClearFields() 

	SELF:oDCKgrnr:Value := ""
	SELF:oDCTxt:TextValue := ""

	RETURN SELF

METHOD Close(oCE) 

	SUPER:Close(oCE)
	GetAppObject():QUIT()

	RETURN SELF

METHOD DisableFields() 

	SELF:oDCKgrnr:Disable()
	SELF:oDCTxt:Disable()
	
	SELF:oDCdlvKgr:Enable()
	SELF:EnableMenuItems()
	SELF:oCCpshOk:Disable()
	SELF:oCCpshCancel:Disable()

	RETURN SELF

METHOD EnableFields() 

	SELF:oDCKgrnr:Enable()
	SELF:oDCTxt:Enable()

	SELF:oDCdlvKgr:Disable()
	SELF:DisableMenuItems()
	SELF:oCCpshOk:Enable()
	SELF:oCCpshCancel:Enable()
	SELF:oDCKgrnr:SetFocus()

	RETURN SELF

METHOD LinkFields() 

	SELF:oDCKgrnr:LinkDF(SELF:Server, SELF:Server:FieldPos(#KGRNR))
	SELF:oDCTxt:LinkDF(SELF:Server, SELF:Server:FieldPos(#TXT))

	RETURN SELF

METHOD PostInit() 
	LOCAL oCol AS ListViewColumn

	SELF:Server:SetOrder("KGRNR")
	SUPER:DoInit()
	
	oCol := ListViewColumn{6,#Kgrnr}
	oCol:Caption := "Gruppe *"
	oCol:Alignment := LVCFMT_RIGHT
	SELF:oDCdlvKgr:AddColumn(oCol)	
	oCol := ListViewColumn{17,#TXT}
	oCol:Caption := "Text"
	SELF:oDCdlvKgr:AddColumn(oCol)	

	SELF:oDCdlvKgr:Server := SELF:Server
	SELF:oDCdlvKgr:SetFocus()

	RETURN SELF	

METHOD pshDelete() 
	
	SELF:DoDelete()
	SELF:oDCdlvKgr:Refresh()

	RETURN SELF

METHOD pshEdit() 
	
	SELF:DoEdit()
	SELF:oDCTxt:SetFocus()
	SELF:oDCKgrnr:Disable()

	RETURN SELF

METHOD pshNew() 
	
	SELF:DoNew()
	SELF:oDCKgrnr:SetFocus()

	RETURN SELF

METHOD pshOk() 

	DO CASE
	CASE SELF:oDCKgrnr:Value < 0
		ErrorBox{, "Die Kundengruppe muß von 0-99 liegen"}:Show()
		SELF:oDCKgrnr:SetFocus()
	CASE Empty(SELF:oDCTxt:TextValue)
		ErrorBox{, "Der Text darf nicht leer sein"}:Show()
		SELF:oDCTxt:SetFocus()
	OTHERWISE
		IF ChkExistKgrnr(SELF:oDCKgrnr:Value, _nRecno)
			ErrorBox{, "Kundengruppe bereits vorhanden"}:Show()
			SELF:oDCKgrnr:SetFocus()
			RETURN SELF
		ENDIF

		IF _nRecno = -1
			IF !SELF:Server:AppendRecycle()
				ErrorBox{, "Fehler beim Einfügen eines Datensatzes"}:Show()
				SELF:oDCKgrnr:SetFocus()
				RETURN SELF
			ENDIF
		ELSE
			SELF:Server:goto(_nRecno)
			IF !SELF:Server:RLOCK()
				ErrorBox{, "Datensatz kann nicht gesperrt werden"}:Show()
				SELF:oDCTxt:SetFocus()
				RETURN SELF
			ENDIF
		ENDIF

		SELF:Server:FIELDPUT(#KGRNR, SELF:oDCKgrnr:Value)
		SELF:Server:FIELDPUT(#TXT, SELF:oDCTxt:TextValue)

		_nRecno := 0
		SELF:Server:Commit()
		SELF:DisableFields()
		SELF:LinkFields()
		SELF:oDCdlvKgr:Refresh()
	ENDCASE

	RETURN SELF

METHOD UnlinkFields() 

	SELF:oDCKgrnr:__unlink()
	SELF:oDCTxt:__unlink()

	RETURN SELF


END CLASS
