﻿CLASS MyDataListView INHERIT DataListView

METHOD FIELDGET(symField) 

	DO CASE
	CASE SELF:Server:NameSym == #AGR
		DO CASE
		CASE symField == #AGRNR
			RETURN StrZero(SELF:Server:FIELDGET(symField), 2)
		OTHERWISE
			RETURN SELF:Server:FIELDGET(symField)
		ENDCASE

	OTHERWISE
		RETURN SELF:Server:FIELDGET(symField)
	ENDCASE


END CLASS
CLASS MyDataWindow INHERIT DataWindow
	PROTECT _nRecno AS INT				// Datensatz beim Edit, -1 beim Insert, ansonsten 0


METHOD ClearFields() 

	RETURN SELF

METHOD DisableFields() 

	RETURN SELF

METHOD DisableMenuItems(oMenu) 

	Default(@oMenu, SELF:Menu)
	
	oMenu:DisableItem(IDM_mnuBrowse_Bearbeiten_Neuer_Datensatz_ID)
	oMenu:DisableItem(IDM_mnuBrowse_Bearbeiten_Datensatz_ändern_ID)
	oMenu:DisableItem(IDM_mnuBrowse_Bearbeiten_Datensatz_löschen_ID)

	oMenu:DisableItem(IDM_mnuBrowse_Bearbeiten_Dateianfang_ID)
	oMenu:DisableItem(IDM_mnuBrowse_Bearbeiten_Vorgänger_ID)
	oMenu:DisableItem(IDM_mnuBrowse_Bearbeiten_Nachfolger_ID)
	oMenu:DisableItem(IDM_mnuBrowse_Bearbeiten_Dateiende_ID)

	RETURN SELF

METHOD Dispatch(oEvent) 

	DO CASE
	CASE oEvent:Message == WM_COMMAND
		IF _nRecno <> 0
			DO CASE
			CASE oEvent:WParam == IDCANCEL	// ESC-Taste
				SELF:pshCancel()
			CASE oEvent:WParam == IDOK			// RETURN-Taste
				SELF:pshOk()
			ENDCASE
		ENDIF
	ENDCASE

	RETURN SUPER:Dispatch(oEvent)


METHOD DoDelete() 
	LOCAL oTB AS TextBox

	IF !SELF:Server:Eof
		IF SELF:Server:RLOCK()
			oTB := TextBox{SELF, SELF:Caption, "Soll der Datensatz gelöscht werden?"}
			oTB:Type := BOXICONQUESTIONMARK + BUTTONYESNO
			IF oTB:Show() == BOXREPLYYES
				// Kein DeleteRecycle() damit Index nicht zusätzlich belastet werden muss!
				SELF:Server:Delete()
				SELF:Server:Skip()
				IF SELF:Server:Eof
					SELF:Server:GoBottom()
				ENDIF
				RETURN TRUE
			ENDIF
		ELSE
			MessageBox(NULL, String2Psz("Datensatz derzeit gesperrt"), String2Psz("Datensatz löschen"), MB_OK+MB_ICONSTOP)
		ENDIF
	ENDIF

	RETURN FALSE


METHOD DoEdit() 

	IF !SELF:Server:Eof
		IF SELF:Server:RLOCK()
			_nRecno := SELF:Server:RECNO
			SELF:UnlinkFields()
			SELF:EnableFields()
		ELSE
			MessageBox(NULL, String2Psz("Datensatz derzeit gesperrt"), String2Psz("Datensatz bearbeiten"), MB_OK+MB_ICONSTOP)
		ENDIF
	ENDIF

	RETURN SELF

METHOD DoInit() 

	SELF:DisableFields()
	IF SELF:Server <> NULL_OBJECT
		SELF:Server:SetFilter({|| !DELETED()}, "!Deleted()")
		SELF:Server:GoTop()
	ENDIF

	RETURN SELF

METHOD DoNew() 

	_nRecno := -1
	SELF:UnlinkFields()
	SELF:ClearFields()
	SELF:EnableFields()

	RETURN SELF

METHOD EnableFields() 

	RETURN SELF

METHOD EnableMenuItems(oMenu) 

	Default(@oMenu, SELF:Menu)

	oMenu:EnableItem(IDM_mnuBrowse_Bearbeiten_Neuer_Datensatz_ID)
	oMenu:EnableItem(IDM_mnuBrowse_Bearbeiten_Datensatz_ändern_ID)
	oMenu:EnableItem(IDM_mnuBrowse_Bearbeiten_Datensatz_löschen_ID)

	oMenu:EnableItem(IDM_mnuBrowse_Bearbeiten_Dateianfang_ID)
	oMenu:EnableItem(IDM_mnuBrowse_Bearbeiten_Vorgänger_ID)
	oMenu:EnableItem(IDM_mnuBrowse_Bearbeiten_Nachfolger_ID)
	oMenu:EnableItem(IDM_mnuBrowse_Bearbeiten_Dateiende_ID)

	RETURN SELF

METHOD HelpContents() 

	SELF:owner:HelpContents()

	RETURN SELF	

METHOD LinkFields() 

	RETURN SELF

METHOD ListViewMouseButtonDoubleClick(oListViewMouseEvent) 

	SELF:pshEdit()

	RETURN SELF

METHOD pshCancel() 
	
	_nRecno := 0
	SELF:Server:Unlock()
	SELF:DisableFields()
	SELF:LinkFields()
	SELF:Server:Skip(0)

	RETURN SELF

METHOD pshClose() 

	RETURN SUPER:Cancel()


METHOD pshEdit() 

	RETURN SELF

METHOD pshOk() 

	RETURN SELF

METHOD QueryClose(oE) 

	IF SELF:Server <> NULL_OBJECT
		SELF:Server:Close()
	ENDIF
	RETURN SUPER:QueryClose(oE)


METHOD UnlinkFields() 

	RETURN SELF


END CLASS
